<script setup lang="ts">
import TimeLine from '@/components/TimeLine.vue'
import { hundredYearsWar, type Story } from '@/models/Story'
import type { StoryEvent } from '@/models/StoryEvent'
import { Map } from 'maplibre-gl'
import 'maplibre-gl/dist/maplibre-gl.css'
import { onMounted, ref, watch, type Ref } from 'vue'
let mapReference: Map | undefined
const story: Story = hundredYearsWar
onMounted(() => {
  const tileServerUrl = import.meta.env.VITE_TILESERVER_URL
  mapReference = new Map({
    container: 'map', // container id
    style: `${tileServerUrl}/styles/basic/style.json`, // style URL
    center: [0, 0], // starting position [lng, lat]
    zoom: 1, // starting zoom
  })
  mapReference.on('load', () => {
    shownEvents.value.push(story.steps[0])
    displayEventOnMap(mapReference!, 0)
  })
})
const displayEventOnMap = async (map: Map, eventIndex: number) => {
  const event = story.steps[eventIndex]
  if (event.imageUrl) {
    const image = await map.loadImage(event.imageUrl!)
    if (map.hasImage('event-image')) {
      map.removeLayer('event-locations')
      map.removeImage('event-image')
      map.removeSource('event-location')
    }
    map.addImage('event-image', image.data)

    map.addSource('event-location', {
      type: 'geojson',
      data: {
        type: 'FeatureCollection',
        features: [
          {
            type: 'Feature',
            geometry: {
              type: 'Point',
              coordinates: [event.location.longitude, event.location.latitude],
            },
            properties: {},
          },
        ],
      },
    })
    map.addLayer({
      id: 'event-locations',
      type: 'symbol',
      source: 'event-location',
      layout: {
        'icon-image': 'event-image',
        //   'icon-size': 1
      },
    })
  }
  if (event.sceneBounds) {
    map.fitBounds(event.sceneBounds, {
      duration: 2000,
    })
  }
}

const currentEventIndex = ref<number>(0)

const shownEvents: Ref<StoryEvent[]> = ref([])
watch(currentEventIndex, () => {
  shownEvents.value.push(story.steps[currentEventIndex.value])
  displayEventOnMap(mapReference!, currentEventIndex.value)
})
</script>

<template>
  <main>
    <section class="map-container">
      <div id="map"></div>
      <p>{{ story.steps[currentEventIndex].description }}</p>
      <button @click="() => (currentEventIndex -= 1)" :disabled="currentEventIndex === 0">
        Previous Event
      </button>
      <button
        @click="() => (currentEventIndex += 1)"
        :disabled="currentEventIndex === story.steps.length - 1"
      >
        Next Event
      </button>
    </section>
    <section id="timeline">
      <TimeLine :story="story" :current-event="story.steps[currentEventIndex]" />
    </section>
  </main>
</template>

<style scoped>
main {
  display: flex;
}
#map {
  min-height: 50vh;
  width: 100%;
}
.map-container {
  width: 50vw;
}
p {
  min-height: 200px;
}
#timeline {
  height: 80vh;
  width: 50vw;
}
</style>
